package
{
	import by.blooddy.crypto.image.JPEGEncoder;
	import flash.display.JPEGEncoderOptions;
	import com.adobe.images.JPGEncoder;
	import flash.utils.ByteArray;
	import flash.geom.Rectangle;
	import flash.utils.getTimer;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.text.TextField;
	
	public class CompressJPEGPerformance extends Sprite
	{
		private var tf:TextField = new TextField();
		
		public function CompressJPEGPerformance()
		{
			tf.width = stage.stageWidth;
			tf.height = stage.stageHeight;
			addChild(tf);
			
			load("Adobe_Flash_Professional_CS5_icon.png", onIconLoaded);
		}
		
		private function onIconLoaded(ev:Event): void
		{
			var bmd:BitmapData = ((ev.target as LoaderInfo).content as Bitmap).bitmapData;
			test("Icon", bmd);
			
			load("10082934002.jpg", onPhotoLoaded);
		}
		
		private function onPhotoLoaded(ev:Event): void
		{
			var bmd:BitmapData = ((ev.target as LoaderInfo).content as Bitmap).bitmapData;
			test("Photo", bmd);
			
			load("Adobe_Flash_Professional_CS5_icon.png", onIconLoadedAgain);
		}
		
		private function onIconLoadedAgain(ev:Event): void
		{
			var bmd:BitmapData = ((ev.target as LoaderInfo).content as Bitmap).bitmapData;
			bmd.noise(Math.random()*int.MAX_VALUE);
			
			test("Noise", bmd);
		}
		
		private function row(...cols): void
		{
			tf.appendText(cols.join(",")+"\n");
			tf.scrollV = tf.maxScrollV;
		}
		
		private function load(url:String, callback:Function): void
		{
			var loader:Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, callback);
			loader.load(new URLRequest(url));
		}
		
		private function test(title:String, bmd:BitmapData): void
		{
			var beforeTime:int;
			var afterTime:int;
			var time:int;
			var rect:Rectangle = new Rectangle(0, 0, bmd.width, bmd.height);
			var bytes:ByteArray;
			
			row(title);
			row("Compressor,Time,Size");
			bmd.getPixel(0, 0);
			
			beforeTime = getTimer();
			bytes = bmd.encode(rect, new JPEGEncoderOptions(25));
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("BitmapData.encode (q=25)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = bmd.encode(rect, new JPEGEncoderOptions(50));
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("BitmapData.encode (q=50)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = bmd.encode(rect, new JPEGEncoderOptions(75));
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("BitmapData.encode (q=75)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = JPEGEncoder.encode(bmd, 25);
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("Blooddy (q=25)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = JPEGEncoder.encode(bmd, 50);
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("Blooddy (q=50)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = JPEGEncoder.encode(bmd, 75);
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("Blooddy (q=75)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = new JPGEncoder(25).encode(bmd);
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("as3corelib (q=25)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = new JPGEncoder(50).encode(bmd);
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("as3corelib (q=50)", time, bytes.length);
			
			beforeTime = getTimer();
			bytes = new JPGEncoder(75).encode(bmd);
			afterTime = getTimer();
			time = afterTime - beforeTime;
			row("as3corelib (q=75)", time, bytes.length);
			
			row();
		}
	}
}
